/*
 * OpenFairDB API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 0.9.3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiCallback;
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.ApiResponse;
import org.openapitools.client.Configuration;
import org.openapitools.client.Pair;
import org.openapitools.client.ProgressRequestBody;
import org.openapitools.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;



import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class CaptchaApi {
    private ApiClient localVarApiClient;

    public CaptchaApi() {
        this(Configuration.getDefaultApiClient());
    }

    public CaptchaApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    /**
     * Build call for captchaCaptchaTokenGet
     * @param captchaToken A unique captcha token  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td>  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Unknown or expired token </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call captchaCaptchaTokenGetCall(String captchaToken, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/captcha/{captcha-token}"
            .replaceAll("\\{" + "captcha-token" + "\\}", localVarApiClient.escapeString(captchaToken.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call captchaCaptchaTokenGetValidateBeforeCall(String captchaToken, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'captchaToken' is set
        if (captchaToken == null) {
            throw new ApiException("Missing the required parameter 'captchaToken' when calling captchaCaptchaTokenGet(Async)");
        }
        

        okhttp3.Call localVarCall = captchaCaptchaTokenGetCall(captchaToken, _callback);
        return localVarCall;

    }

    /**
     * Get the captcha challenge
     * Returns an image with a captcha challenge for the given token. 
     * @param captchaToken A unique captcha token  (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td>  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Unknown or expired token </td><td>  -  </td></tr>
     </table>
     */
    public void captchaCaptchaTokenGet(String captchaToken) throws ApiException {
        captchaCaptchaTokenGetWithHttpInfo(captchaToken);
    }

    /**
     * Get the captcha challenge
     * Returns an image with a captcha challenge for the given token. 
     * @param captchaToken A unique captcha token  (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td>  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Unknown or expired token </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Void> captchaCaptchaTokenGetWithHttpInfo(String captchaToken) throws ApiException {
        okhttp3.Call localVarCall = captchaCaptchaTokenGetValidateBeforeCall(captchaToken, null);
        return localVarApiClient.execute(localVarCall);
    }

    /**
     * Get the captcha challenge (asynchronously)
     * Returns an image with a captcha challenge for the given token. 
     * @param captchaToken A unique captcha token  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td>  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Unknown or expired token </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call captchaCaptchaTokenGetAsync(String captchaToken, final ApiCallback<Void> _callback) throws ApiException {

        okhttp3.Call localVarCall = captchaCaptchaTokenGetValidateBeforeCall(captchaToken, _callback);
        localVarApiClient.executeAsync(localVarCall, _callback);
        return localVarCall;
    }
    /**
     * Build call for captchaCaptchaTokenVerifyPost
     * @param captchaToken A unique captcha token  (required)
     * @param body  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The answer to the capcha challenge was correct.  A token is returned in a cookie named &#x60;ofdb-captcha&#x60;. You need to include this cookie in subsequent requests.  </td><td>  * Set-Cookie -  <br>  </td></tr>
        <tr><td> 400 </td><td> The answer to the capcha challenge was not correct </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call captchaCaptchaTokenVerifyPostCall(String captchaToken, String body, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = body;

        // create path and map variables
        String localVarPath = "/captcha/{captcha-token}/verify"
            .replaceAll("\\{" + "captcha-token" + "\\}", localVarApiClient.escapeString(captchaToken.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "text/plain"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call captchaCaptchaTokenVerifyPostValidateBeforeCall(String captchaToken, String body, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'captchaToken' is set
        if (captchaToken == null) {
            throw new ApiException("Missing the required parameter 'captchaToken' when calling captchaCaptchaTokenVerifyPost(Async)");
        }
        
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling captchaCaptchaTokenVerifyPost(Async)");
        }
        

        okhttp3.Call localVarCall = captchaCaptchaTokenVerifyPostCall(captchaToken, body, _callback);
        return localVarCall;

    }

    /**
     * Verify a captcha answer for the given token
     * 
     * @param captchaToken A unique captcha token  (required)
     * @param body  (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The answer to the capcha challenge was correct.  A token is returned in a cookie named &#x60;ofdb-captcha&#x60;. You need to include this cookie in subsequent requests.  </td><td>  * Set-Cookie -  <br>  </td></tr>
        <tr><td> 400 </td><td> The answer to the capcha challenge was not correct </td><td>  -  </td></tr>
     </table>
     */
    public void captchaCaptchaTokenVerifyPost(String captchaToken, String body) throws ApiException {
        captchaCaptchaTokenVerifyPostWithHttpInfo(captchaToken, body);
    }

    /**
     * Verify a captcha answer for the given token
     * 
     * @param captchaToken A unique captcha token  (required)
     * @param body  (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The answer to the capcha challenge was correct.  A token is returned in a cookie named &#x60;ofdb-captcha&#x60;. You need to include this cookie in subsequent requests.  </td><td>  * Set-Cookie -  <br>  </td></tr>
        <tr><td> 400 </td><td> The answer to the capcha challenge was not correct </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Void> captchaCaptchaTokenVerifyPostWithHttpInfo(String captchaToken, String body) throws ApiException {
        okhttp3.Call localVarCall = captchaCaptchaTokenVerifyPostValidateBeforeCall(captchaToken, body, null);
        return localVarApiClient.execute(localVarCall);
    }

    /**
     * Verify a captcha answer for the given token (asynchronously)
     * 
     * @param captchaToken A unique captcha token  (required)
     * @param body  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The answer to the capcha challenge was correct.  A token is returned in a cookie named &#x60;ofdb-captcha&#x60;. You need to include this cookie in subsequent requests.  </td><td>  * Set-Cookie -  <br>  </td></tr>
        <tr><td> 400 </td><td> The answer to the capcha challenge was not correct </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call captchaCaptchaTokenVerifyPostAsync(String captchaToken, String body, final ApiCallback<Void> _callback) throws ApiException {

        okhttp3.Call localVarCall = captchaCaptchaTokenVerifyPostValidateBeforeCall(captchaToken, body, _callback);
        localVarApiClient.executeAsync(localVarCall, _callback);
        return localVarCall;
    }
    /**
     * Build call for captchaPost
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td>  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call captchaPostCall(final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/captcha";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call captchaPostValidateBeforeCall(final ApiCallback _callback) throws ApiException {
        

        okhttp3.Call localVarCall = captchaPostCall(_callback);
        return localVarCall;

    }

    /**
     * Request a new captcha challenge
     * 
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td>  </td><td>  -  </td></tr>
     </table>
     */
    public void captchaPost() throws ApiException {
        captchaPostWithHttpInfo();
    }

    /**
     * Request a new captcha challenge
     * 
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td>  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Void> captchaPostWithHttpInfo() throws ApiException {
        okhttp3.Call localVarCall = captchaPostValidateBeforeCall(null);
        return localVarApiClient.execute(localVarCall);
    }

    /**
     * Request a new captcha challenge (asynchronously)
     * 
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td>  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call captchaPostAsync(final ApiCallback<Void> _callback) throws ApiException {

        okhttp3.Call localVarCall = captchaPostValidateBeforeCall(_callback);
        localVarApiClient.executeAsync(localVarCall, _callback);
        return localVarCall;
    }
}
